import javax.microedition.midlet.* ;
import javax.microedition.lcdui.* ;
import com.j_phone.media.* ;
import com.j_phone.system.DeviceControl ;



public class tc extends Canvas implements Runnable {

	private sswc     sswc_ ;
	private Thread   mythread ;
	private MediaPlayer sp ;
	private DeviceControl dc ;

	private long     targettime ;
	private int      nowtime ;
	private int      mymode ;
	private int      timeset ;
	private int      currentketa ;
	private static final  int[] KETA =
		{10, 100, 1000, 10000, 60000, 600000, 3600000 } ;

	public  tc( sswc  c){
		sswc_ = c ;
		mymode = 0 ;
		timeset = 180000 ;
		targettime = 0 ;
		nowtime = timeset ;
		currentketa = 4 ;
		dc = DeviceControl.getDefaultDeviceControl() ;
		try {
			byte[] data = new byte[8192] ;
			java.io.InputStream in = getClass().getResourceAsStream("/s.mmf") ;
			in.read( data, 0, data.length) ;
			in.close() ;
			sp = new MediaPlayer( data) ;
		} catch ( Exception e){
		}
		mythread = new Thread( this) ;
		addCommand( new Command("config", Command.ITEM, 101)) ;
		addCommand( new Command("usage",  Command.ITEM, 1022)) ;
		addCommand( new Command("mode-s",  Command.ITEM, 11)) ;
		setCommandListener( sswc_) ;
		return ;
	}

	public void  run () {
		Thread thisthread = Thread.currentThread () ;
		do {
			try {
				nowtime = (int)(
					targettime - (new java.util.Date()).getTime()
				) ;
				repaint () ;
				if( nowtime<=0){
					mythread = null ;
					mymode = 3 ;
					try {
						sp.play( true) ;
						dc.setDeviceActive( DeviceControl.VIBRATION, true) ;
						Thread.sleep( sswc_.ringtime) ;
					} catch( Exception e){
System.out.println( e) ;
System.out.println( e.getMessage()) ;
					}
					if( mymode==3){
						keyPressed( KEY_POUND) ;
					}
				}
				Thread.sleep( sswc_.waittime) ;
			} catch( Exception e){
			}
		} while( thisthread == mythread) ;
		return ;
	}

	public void  paint( Graphics g){
		g.setColor( 130815) ;

		g.fillRect( 0, 0, sswc_.width, sswc_.height) ;
		g.setColor( 0) ;
		g.drawString( "", 100-19*currentketa+sswc_.offsetw, 45+sswc_.offseth, Graphics.TOP|Graphics.LEFT) ;
		g.drawString( "[set]", 5+sswc_.offsetw, 5+sswc_.offseth, Graphics.TOP|Graphics.LEFT) ;
		g.drawString( "[now]", 5+sswc_.offsetw, 65+sswc_.offseth, Graphics.TOP|Graphics.LEFT) ;
		sswc_.drawTime( g, timeset, sswc_.offseth+20) ;
		sswc_.drawTime( g, nowtime, sswc_.offseth+80) ;

		return ;
	}

	public void keyPressed( int keycode){
		keycode = sswc_.getMyGameAction( keycode) ;
		switch( mymode){
			case  0 :
				int i, j;
				switch( keycode){
					case  KEY_STAR :
					case  KEY_POUND :
					case  FIRE :
						mymode = 1 ;
						targettime = timeset + (new java.util.Date()).getTime() ;
						mythread.start() ;
						return ;
					case  KEY_NUM0 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i ;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM1 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa];
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM2 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*2;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM3 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*3;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM4 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*4;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM5 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*5;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM6 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*6;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM7 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*7;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM8 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*8;
						keyPressed( RIGHT) ;
						return ;
					case  KEY_NUM9 :
						i = timeset%KETA[currentketa];
						j = timeset%KETA[currentketa+1];
						timeset = timeset - j + i + KETA[currentketa]*9;
						keyPressed( RIGHT) ;
						return ;

					case  UP :
						timeset += KETA[currentketa] ;
						break ;
					case  DOWN :
						timeset -= KETA[currentketa] ;
						break ;
					case  LEFT :
						if( currentketa>=5){
							return ;
						}
						currentketa++ ;
						break ;
					case  RIGHT:
						if( currentketa>0){
							currentketa-- ;
						}
						break ;
					default :
					return ;
				}
				check() ;
				repaint() ;
				return ;

			case  1 :
				switch( keycode){
					case  KEY_NUM0 :
					case  KEY_NUM1 :
					case  KEY_NUM2 :
					case  KEY_NUM3 :
					case  KEY_NUM4 :
					case  KEY_NUM5 :
					case  KEY_NUM6 :
					case  KEY_NUM7 :
					case  KEY_NUM8 :
					case  KEY_NUM9 :
					case  KEY_POUND :
					case  KEY_STAR :
					case  FIRE :
						mythread = null ;
						targettime -= (new java.util.Date()).getTime() ;
						mythread = new Thread( this) ;
						mymode = 2 ;
						return ;
					default :
						return ;
				}

			case  2 :
				switch( keycode){
					case  KEY_STAR :
						mymode = 0 ;
						nowtime = timeset ;
						repaint() ;
						return ;

					case  UP :
					case  DOWN :
					case  LEFT :
					case  RIGHT :
						mymode = 0 ;
						nowtime = timeset ;
						keyPressed( keycode) ;
						return ;

					case  KEY_NUM0 :
					case  KEY_NUM1 :
					case  KEY_NUM2 :
					case  KEY_NUM3 :
					case  KEY_NUM4 :
					case  KEY_NUM5 :
					case  KEY_NUM6 :
					case  KEY_NUM7 :
					case  KEY_NUM8 :
					case  KEY_NUM9 :
					case  KEY_POUND :
					case  FIRE :
						targettime += (new java.util.Date()).getTime() ;
						mymode = 1 ;
						mythread.start() ;
						return ;
					default :
					return ;
				}

			case  3 :
System.out.println( "~߂ȂƂ") ;
				switch( keycode){
					case  KEY_NUM0 :
					case  KEY_NUM1 :
					case  KEY_NUM2 :
					case  KEY_NUM3 :
					case  KEY_NUM4 :
					case  KEY_NUM5 :
					case  KEY_NUM6 :
					case  KEY_NUM7 :
					case  KEY_NUM8 :
					case  KEY_NUM9 :
					case  KEY_POUND :
					case  KEY_STAR :
					case  FIRE :
						dc.setDeviceActive( DeviceControl.VIBRATION, false) ;
						sp.stop() ;
						mymode = 0 ;
						nowtime = timeset ;
						mythread = new Thread( this) ;
						repaint() ;
						return ;
					default :
						return ;
				}

			default :
				return ;
		}
	}
	private void check () {
		if( timeset<0){
			timeset = 0 ;
		} else if( timeset>=KETA[6]){
			timeset=KETA[6]-1 ;
		}
		return ;
	}
}
